]>
Commit | Line | Data |
---|---|---|
08785f48 | 1 | #!/bin/sh |
ecbed728 | 2 | # Enable automatic program execution by the kernel. |
08785f48 | 3 | |
7c81570d RH |
4 | qemu_target_list="i386 i486 alpha arm armeb sparc sparc32plus sparc64 \ |
5 | ppc ppc64 ppc64le m68k mips mipsel mipsn32 mipsn32el mips64 mips64el \ | |
ecbed728 | 6 | sh4 sh4eb s390x aarch64 aarch64_be hppa riscv32 riscv64 xtensa xtensaeb \ |
0caebb91 | 7 | microblaze microblazeel or1k x86_64 hexagon loongarch64" |
3bef0451 LV |
8 | |
9 | i386_magic='\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x03\x00' | |
daf238dc | 10 | i386_mask='\xff\xff\xff\xff\xff\xfe\xfe\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff' |
3bef0451 LV |
11 | i386_family=i386 |
12 | ||
13 | i486_magic='\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x06\x00' | |
daf238dc | 14 | i486_mask='\xff\xff\xff\xff\xff\xfe\xfe\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff' |
3bef0451 LV |
15 | i486_family=i386 |
16 | ||
b8dbfc9c LV |
17 | x86_64_magic='\x7fELF\x02\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x3e\x00' |
18 | x86_64_mask='\xff\xff\xff\xff\xff\xfe\xfe\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff' | |
19 | x86_64_family=i386 | |
20 | ||
3bef0451 | 21 | alpha_magic='\x7fELF\x02\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x26\x90' |
daf238dc | 22 | alpha_mask='\xff\xff\xff\xff\xff\xfe\xfe\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff' |
3bef0451 LV |
23 | alpha_family=alpha |
24 | ||
25 | arm_magic='\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x28\x00' | |
26 | arm_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff' | |
27 | arm_family=arm | |
28 | ||
29 | armeb_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x28' | |
30 | armeb_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff' | |
2ced93ee | 31 | armeb_family=armeb |
3bef0451 LV |
32 | |
33 | sparc_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x02' | |
daf238dc | 34 | sparc_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff' |
3bef0451 LV |
35 | sparc_family=sparc |
36 | ||
37 | sparc32plus_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x12' | |
daf238dc | 38 | sparc32plus_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff' |
3bef0451 LV |
39 | sparc32plus_family=sparc |
40 | ||
7c81570d RH |
41 | sparc64_magic='\x7fELF\x02\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x2b' |
42 | sparc64_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff' | |
43 | sparc64_family=sparc | |
44 | ||
3bef0451 LV |
45 | ppc_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x14' |
46 | ppc_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff' | |
47 | ppc_family=ppc | |
48 | ||
49 | ppc64_magic='\x7fELF\x02\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x15' | |
50 | ppc64_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff' | |
51 | ppc64_family=ppc | |
52 | ||
53 | ppc64le_magic='\x7fELF\x02\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x15\x00' | |
54 | ppc64le_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\x00' | |
55 | ppc64le_family=ppcle | |
56 | ||
57 | m68k_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x04' | |
daf238dc | 58 | m68k_mask='\xff\xff\xff\xff\xff\xff\xfe\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff' |
3bef0451 LV |
59 | m68k_family=m68k |
60 | ||
61 | # FIXME: We could use the other endianness on a MIPS host. | |
62 | ||
77d119dd AH |
63 | mips_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x08\x00\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00' |
64 | mips_mask='\xff\xff\xff\xff\xff\xff\xff\x00\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff\xff\xff\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x20' | |
3bef0451 LV |
65 | mips_family=mips |
66 | ||
77d119dd AH |
67 | mipsel_magic='\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x08\x00\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00' |
68 | mipsel_mask='\xff\xff\xff\xff\xff\xff\xff\x00\x00\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff\xff\xff\xff\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x20\x00\x00\x00' | |
3bef0451 LV |
69 | mipsel_family=mips |
70 | ||
77d119dd AH |
71 | mipsn32_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x08\x00\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x20' |
72 | mipsn32_mask='\xff\xff\xff\xff\xff\xff\xff\x00\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff\xff\xff\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x20' | |
3bef0451 LV |
73 | mipsn32_family=mips |
74 | ||
77d119dd AH |
75 | mipsn32el_magic='\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x08\x00\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x20\x00\x00\x00' |
76 | mipsn32el_mask='\xff\xff\xff\xff\xff\xff\xff\x00\x00\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff\xff\xff\xff\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x20\x00\x00\x00' | |
3bef0451 LV |
77 | mipsn32el_family=mips |
78 | ||
79 | mips64_magic='\x7fELF\x02\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x08' | |
77d119dd | 80 | mips64_mask='\xff\xff\xff\xff\xff\xff\xff\x00\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff' |
3bef0451 LV |
81 | mips64_family=mips |
82 | ||
83 | mips64el_magic='\x7fELF\x02\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x08\x00' | |
77d119dd | 84 | mips64el_mask='\xff\xff\xff\xff\xff\xff\xff\x00\x00\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff' |
3bef0451 LV |
85 | mips64el_family=mips |
86 | ||
87 | sh4_magic='\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x2a\x00' | |
daf238dc | 88 | sh4_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff' |
3bef0451 LV |
89 | sh4_family=sh4 |
90 | ||
91 | sh4eb_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x2a' | |
daf238dc | 92 | sh4eb_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff' |
3bef0451 LV |
93 | sh4eb_family=sh4 |
94 | ||
95 | s390x_magic='\x7fELF\x02\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x16' | |
daf238dc | 96 | s390x_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff' |
3bef0451 LV |
97 | s390x_family=s390x |
98 | ||
99 | aarch64_magic='\x7fELF\x02\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\xb7\x00' | |
100 | aarch64_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff' | |
101 | aarch64_family=arm | |
102 | ||
f772f212 MW |
103 | aarch64_be_magic='\x7fELF\x02\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\xb7' |
104 | aarch64_be_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff' | |
2ced93ee | 105 | aarch64_be_family=armeb |
f772f212 | 106 | |
e4d966cc LV |
107 | hppa_magic='\x7f\x45\x4c\x46\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x0f' |
108 | hppa_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff' | |
109 | hppa_family=hppa | |
110 | ||
25fa194b MC |
111 | riscv32_magic='\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\xf3\x00' |
112 | riscv32_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff' | |
113 | riscv32_family=riscv | |
114 | ||
115 | riscv64_magic='\x7fELF\x02\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\xf3\x00' | |
116 | riscv64_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff' | |
117 | riscv64_family=riscv | |
118 | ||
d4090306 MF |
119 | xtensa_magic='\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x5e\x00' |
120 | xtensa_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff' | |
121 | xtensa_family=xtensa | |
122 | ||
123 | xtensaeb_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x5e' | |
124 | xtensaeb_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff' | |
125 | xtensaeb_family=xtensaeb | |
126 | ||
947aeab3 LV |
127 | microblaze_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\xba\xab' |
128 | microblaze_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff' | |
129 | microblaze_family=microblaze | |
130 | ||
131 | microblazeel_magic='\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\xab\xba' | |
132 | microblazeel_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff' | |
133 | microblazeel_family=microblazeel | |
134 | ||
ecbed728 RH |
135 | or1k_magic='\x7fELF\x01\x02\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x5c' |
136 | or1k_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff' | |
137 | or1k_family=or1k | |
138 | ||
3e7a84ee TS |
139 | hexagon_magic='\x7fELF\x01\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\xa4\x00' |
140 | hexagon_mask='\xff\xff\xff\xff\xff\xff\xff\x00\xff\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff' | |
141 | hexagon_family=hexagon | |
142 | ||
0caebb91 SG |
143 | loongarch64_magic='\x7fELF\x02\x01\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x00\x02\x01' |
144 | loongarch64_mask='\xff\xff\xff\xff\xff\xff\xff\xfc\x00\xff\xff\xff\xff\xff\xff\xff\xfe\xff\xff\xff' | |
145 | loongarch64_family=loongarch | |
146 | ||
3bef0451 LV |
147 | qemu_get_family() { |
148 | cpu=${HOST_ARCH:-$(uname -m)} | |
149 | case "$cpu" in | |
150 | amd64|i386|i486|i586|i686|i86pc|BePC|x86_64) | |
151 | echo "i386" | |
152 | ;; | |
153 | mips*) | |
154 | echo "mips" | |
155 | ;; | |
156 | "Power Macintosh"|ppc64|powerpc|ppc) | |
157 | echo "ppc" | |
158 | ;; | |
159 | ppc64el|ppc64le) | |
160 | echo "ppcle" | |
161 | ;; | |
2ced93ee | 162 | arm|armel|armhf|arm64|armv[4-9]*l|aarch64) |
3bef0451 LV |
163 | echo "arm" |
164 | ;; | |
2ced93ee MW |
165 | armeb|armv[4-9]*b|aarch64_be) |
166 | echo "armeb" | |
167 | ;; | |
3bef0451 LV |
168 | sparc*) |
169 | echo "sparc" | |
170 | ;; | |
25fa194b MC |
171 | riscv*) |
172 | echo "riscv" | |
173 | ;; | |
f8d1ae82 SG |
174 | loongarch*) |
175 | echo "loongarch" | |
176 | ;; | |
3bef0451 LV |
177 | *) |
178 | echo "$cpu" | |
179 | ;; | |
180 | esac | |
181 | } | |
182 | ||
183 | usage() { | |
184 | cat <<EOF | |
185 | Usage: qemu-binfmt-conf.sh [--qemu-path PATH][--debian][--systemd CPU] | |
186 | [--help][--credential yes|no][--exportdir PATH] | |
7155be7c | 187 | [--persistent yes|no][--qemu-suffix SUFFIX] |
6e1c0d7b | 188 | [--preserve-argv0 yes|no] |
3bef0451 LV |
189 | |
190 | Configure binfmt_misc to use qemu interpreter | |
191 | ||
6e1c0d7b LV |
192 | --help: display this usage |
193 | --qemu-path: set path to qemu interpreter ($QEMU_PATH) | |
194 | --qemu-suffix: add a suffix to the default interpreter name | |
195 | --debian: don't write into /proc, | |
196 | instead generate update-binfmts templates | |
197 | --systemd: don't write into /proc, | |
198 | instead generate file for systemd-binfmt.service | |
199 | for the given CPU. If CPU is "ALL", generate a | |
200 | file for all known cpus | |
201 | --exportdir: define where to write configuration files | |
202 | (default: $SYSTEMDDIR or $DEBIANDIR) | |
203 | --credential: if yes, credential and security tokens are | |
204 | calculated according to the binary to interpret | |
205 | --persistent: if yes, the interpreter is loaded when binfmt is | |
206 | configured and remains in memory. All future uses | |
207 | are cloned from the open file. | |
208 | --preserve-argv0 preserve argv[0] | |
3bef0451 LV |
209 | |
210 | To import templates with update-binfmts, use : | |
211 | ||
212 | sudo update-binfmts --importdir ${EXPORTDIR:-$DEBIANDIR} --import qemu-CPU | |
213 | ||
214 | To remove interpreter, use : | |
215 | ||
216 | sudo update-binfmts --package qemu-CPU --remove qemu-CPU $QEMU_PATH | |
217 | ||
218 | With systemd, binfmt files are loaded by systemd-binfmt.service | |
219 | ||
220 | The environment variable HOST_ARCH allows to override 'uname' to generate | |
221 | configuration files for a different architecture than the current one. | |
222 | ||
223 | where CPU is one of: | |
224 | ||
225 | $qemu_target_list | |
226 | ||
227 | EOF | |
228 | } | |
229 | ||
230 | qemu_check_access() { | |
231 | if [ ! -w "$1" ] ; then | |
232 | echo "ERROR: cannot write to $1" 1>&2 | |
233 | exit 1 | |
234 | fi | |
235 | } | |
236 | ||
237 | qemu_check_bintfmt_misc() { | |
238 | # load the binfmt_misc module | |
239 | if [ ! -d /proc/sys/fs/binfmt_misc ]; then | |
240 | if ! /sbin/modprobe binfmt_misc ; then | |
241 | exit 1 | |
242 | fi | |
243 | fi | |
244 | if [ ! -f /proc/sys/fs/binfmt_misc/register ]; then | |
245 | if ! mount binfmt_misc -t binfmt_misc /proc/sys/fs/binfmt_misc ; then | |
246 | exit 1 | |
247 | fi | |
248 | fi | |
249 | ||
250 | qemu_check_access /proc/sys/fs/binfmt_misc/register | |
251 | } | |
252 | ||
253 | installed_dpkg() { | |
254 | dpkg --status "$1" > /dev/null 2>&1 | |
255 | } | |
256 | ||
257 | qemu_check_debian() { | |
258 | if [ ! -e /etc/debian_version ] ; then | |
259 | echo "WARNING: your system is not a Debian based distro" 1>&2 | |
260 | elif ! installed_dpkg binfmt-support ; then | |
261 | echo "WARNING: package binfmt-support is needed" 1>&2 | |
262 | fi | |
263 | qemu_check_access "$EXPORTDIR" | |
264 | } | |
265 | ||
266 | qemu_check_systemd() { | |
267 | if ! systemctl -q is-enabled systemd-binfmt.service ; then | |
268 | echo "WARNING: systemd-binfmt.service is missing or disabled" 1>&2 | |
269 | fi | |
270 | qemu_check_access "$EXPORTDIR" | |
271 | } | |
272 | ||
273 | qemu_generate_register() { | |
70a77984 LV |
274 | flags="" |
275 | if [ "$CREDENTIAL" = "yes" ] ; then | |
276 | flags="OC" | |
277 | fi | |
01ecd22a LV |
278 | if [ "$PERSISTENT" = "yes" ] ; then |
279 | flags="${flags}F" | |
280 | fi | |
6e1c0d7b LV |
281 | if [ "$PRESERVE_ARG0" = "yes" ] ; then |
282 | flags="${flags}P" | |
283 | fi | |
70a77984 LV |
284 | |
285 | echo ":qemu-$cpu:M::$magic:$mask:$qemu:$flags" | |
3bef0451 LV |
286 | } |
287 | ||
288 | qemu_register_interpreter() { | |
289 | echo "Setting $qemu as binfmt interpreter for $cpu" | |
290 | qemu_generate_register > /proc/sys/fs/binfmt_misc/register | |
291 | } | |
292 | ||
293 | qemu_generate_systemd() { | |
294 | echo "Setting $qemu as binfmt interpreter for $cpu for systemd-binfmt.service" | |
295 | qemu_generate_register > "$EXPORTDIR/qemu-$cpu.conf" | |
296 | } | |
297 | ||
298 | qemu_generate_debian() { | |
299 | cat > "$EXPORTDIR/qemu-$cpu" <<EOF | |
300 | package qemu-$cpu | |
301 | interpreter $qemu | |
302 | magic $magic | |
303 | mask $mask | |
e7594133 SCC |
304 | credentials $CREDENTIAL |
305 | preserve $PRESERVE_ARG0 | |
306 | fix_binary $PERSISTENT | |
3bef0451 | 307 | EOF |
3bef0451 LV |
308 | } |
309 | ||
310 | qemu_set_binfmts() { | |
311 | # probe cpu type | |
312 | host_family=$(qemu_get_family) | |
313 | ||
314 | # register the interpreter for each cpu except for the native one | |
315 | ||
316 | for cpu in ${qemu_target_list} ; do | |
317 | magic=$(eval echo \$${cpu}_magic) | |
318 | mask=$(eval echo \$${cpu}_mask) | |
319 | family=$(eval echo \$${cpu}_family) | |
320 | ||
321 | if [ "$magic" = "" ] || [ "$mask" = "" ] || [ "$family" = "" ] ; then | |
322 | echo "INTERNAL ERROR: unknown cpu $cpu" 1>&2 | |
323 | continue | |
324 | fi | |
325 | ||
326 | qemu="$QEMU_PATH/qemu-$cpu" | |
327 | if [ "$cpu" = "i486" ] ; then | |
328 | qemu="$QEMU_PATH/qemu-i386" | |
329 | fi | |
330 | ||
7155be7c | 331 | qemu="$qemu$QEMU_SUFFIX" |
3bef0451 LV |
332 | if [ "$host_family" != "$family" ] ; then |
333 | $BINFMT_SET | |
334 | fi | |
335 | done | |
336 | } | |
337 | ||
338 | CHECK=qemu_check_bintfmt_misc | |
339 | BINFMT_SET=qemu_register_interpreter | |
340 | ||
341 | SYSTEMDDIR="/etc/binfmt.d" | |
342 | DEBIANDIR="/usr/share/binfmts" | |
343 | ||
344 | QEMU_PATH=/usr/local/bin | |
70a77984 | 345 | CREDENTIAL=no |
01ecd22a | 346 | PERSISTENT=no |
6e1c0d7b | 347 | PRESERVE_ARG0=no |
7155be7c | 348 | QEMU_SUFFIX="" |
3bef0451 | 349 | |
719fab3a MW |
350 | _longopts="debian,systemd:,qemu-path:,qemu-suffix:,exportdir:,help,credential:,\ |
351 | persistent:,preserve-argv0:" | |
352 | options=$(getopt -o ds:Q:S:e:hc:p:g:F: -l ${_longopts} -- "$@") | |
3bef0451 LV |
353 | eval set -- "$options" |
354 | ||
355 | while true ; do | |
356 | case "$1" in | |
357 | -d|--debian) | |
358 | CHECK=qemu_check_debian | |
359 | BINFMT_SET=qemu_generate_debian | |
360 | EXPORTDIR=${EXPORTDIR:-$DEBIANDIR} | |
361 | ;; | |
362 | -s|--systemd) | |
363 | CHECK=qemu_check_systemd | |
364 | BINFMT_SET=qemu_generate_systemd | |
365 | EXPORTDIR=${EXPORTDIR:-$SYSTEMDDIR} | |
366 | shift | |
367 | # check given cpu is in the supported CPU list | |
3ff48453 LV |
368 | if [ "$1" != "ALL" ] ; then |
369 | for cpu in ${qemu_target_list} ; do | |
370 | if [ "$cpu" = "$1" ] ; then | |
371 | break | |
372 | fi | |
373 | done | |
374 | ||
6f75023a | 375 | if [ "$cpu" = "$1" ] ; then |
3ff48453 LV |
376 | qemu_target_list="$1" |
377 | else | |
378 | echo "ERROR: unknown CPU \"$1\"" 1>&2 | |
379 | usage | |
380 | exit 1 | |
3bef0451 | 381 | fi |
3bef0451 LV |
382 | fi |
383 | ;; | |
384 | -Q|--qemu-path) | |
385 | shift | |
386 | QEMU_PATH="$1" | |
387 | ;; | |
7155be7c LV |
388 | -F|--qemu-suffix) |
389 | shift | |
390 | QEMU_SUFFIX="$1" | |
391 | ;; | |
3bef0451 LV |
392 | -e|--exportdir) |
393 | shift | |
394 | EXPORTDIR="$1" | |
395 | ;; | |
396 | -h|--help) | |
397 | usage | |
398 | exit 1 | |
399 | ;; | |
400 | -c|--credential) | |
401 | shift | |
70a77984 | 402 | CREDENTIAL="$1" |
3bef0451 | 403 | ;; |
01ecd22a LV |
404 | -p|--persistent) |
405 | shift | |
406 | PERSISTENT="$1" | |
3bef0451 | 407 | ;; |
6e1c0d7b LV |
408 | -g|--preserve-argv0) |
409 | shift | |
410 | PRESERVE_ARG0="$1" | |
411 | ;; | |
3bef0451 LV |
412 | *) |
413 | break | |
414 | ;; | |
415 | esac | |
416 | shift | |
417 | done | |
418 | ||
419 | $CHECK | |
420 | qemu_set_binfmts |